﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace LagoonZSTEditor
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            m_items = new ItemGroup(20, 200, 5, new ItemGroup.Item[] {
                new ItemGroup.Item(0x00000080, "Healing Pot"),                
                new ItemGroup.Item(0x00000040, "Shiny Ball"),
                new ItemGroup.Item(0x00000020, "Shiny Stone"),
                new ItemGroup.Item(0x00000010, "Elixir"),
                new ItemGroup.Item(0x00000008, "Bright Stone"),
                new ItemGroup.Item(0x00000004, "Life Ball"),
                new ItemGroup.Item(0x00000002, "Samson's Key"),
                new ItemGroup.Item(0x00000001, "Key of Philips"),
                new ItemGroup.Item(0x00008000, "Key of Prison"),
                new ItemGroup.Item(0x00004000, "Mint"),
                new ItemGroup.Item(0x00002000, "Duma's Key"),
                new ItemGroup.Item(0x00001000, "Key of Siegfried"),
                new ItemGroup.Item(0x00000800, "Movable Mantle"),
                new ItemGroup.Item(0x00000400, "Ancient Book"),
                new ItemGroup.Item(0x00000200, "Freezing Pot"),
                new ItemGroup.Item(0x00000100, "Thor's Pendant"),
                new ItemGroup.Item(0x00800000, "Powerful Mirror"),                
                new ItemGroup.Item(0x00400000, "Moon Stone"),
                new ItemGroup.Item(0x00200000, "Angel's Bell"),
                new ItemGroup.Item(0x00100000, "Truth Fire"),
                new ItemGroup.Item(0x00080000, "Fur Mantle"),
                new ItemGroup.Item(0x00040000, "Statue"),
                new ItemGroup.Item(0x00020000, "Tablet of Faith"),
                new ItemGroup.Item(0x00010000, "Tablet of Wish"),
                new ItemGroup.Item(0x80000000, "Tablet of Hope"),
            });

            m_equipment = new ItemGroup(20, 400, 5, new ItemGroup.Item[] {
                new ItemGroup.Item(0x00000040, "Short Sword"),
                new ItemGroup.Item(0x00000020 , "Silver Sword"),
                new ItemGroup.Item(0x00000010 , "Magic Sword"),
                new ItemGroup.Item(0x00000008 , "Force Sword"),
                new ItemGroup.Item(0x00000004 , "Moon Sword"),
                new ItemGroup.Item(0x00000002 , "Bandit Armor"),
                new ItemGroup.Item(0x00000001 , "Gold Armor"),
                new ItemGroup.Item(0x00008000 , "Sonic armor"),
                new ItemGroup.Item(0x00004000 , "Thunder armor"),
                new ItemGroup.Item(0x00002000 , "Moon Armor"),
                new ItemGroup.Item(0x00001000 , "Small Shield"),
                new ItemGroup.Item(0x00000800 , "Large Shield"),
                new ItemGroup.Item(0x00000400 , "Great Shield"),
                new ItemGroup.Item(0x00000200 , "Maxim Shield"),
                new ItemGroup.Item(0x00000100 , "Moon Shield"),                
                new ItemGroup.Item(0x00800000 , "Protective Ring"),
                new ItemGroup.Item(0x00400000 , "Power Ring"),
                new ItemGroup.Item(0x00200000 , "Defensive Ring"),
                new ItemGroup.Item(0x00100000 , "Curing Ring"),
                new ItemGroup.Item(0x00080000 , "Time Ring"),                
                new ItemGroup.Item(0x00040000 , "Earth Staff"),
                new ItemGroup.Item(0x00020000 , "Sky Staff"),
                new ItemGroup.Item(0x00010000 , "Star Staff"),                
                new ItemGroup.Item(0x80000000 , "Moon Staff"),
                new ItemGroup.Item(0x40000000 , "Fire Crystal"),
                new ItemGroup.Item(0x20000000 , "Wind Crystal"),
                new ItemGroup.Item(0x10000000 , "Water Crystal"),
                new ItemGroup.Item(0x08000000 , "Thunder Crystal"),
            });
            
            for (int i = 0; i < m_items.Items.Length; i++)
            {
                this.Controls.Add(m_items.Items[i]);
            }
            for (int i = 0; i < m_equipment.Items.Length; i++)
            {
                this.Controls.Add(m_equipment.Items[i]);
            }

            m_levels = new Level[] {
                new Level(1, 10, 10, 3, 10, 5), 
                new Level(2, 40, 17, 8, 13, 10), 
                new Level(3, 90, 23, 10, 17, 16), 
                new Level(4, 170, 28, 12, 22, 19), 
                new Level(5, 280, 36, 19, 26, 23), 
                new Level(6, 400, 43, 22, 30, 26), 
                new Level(7, 560, 54, 27, 34, 31), 
                new Level(8, 750, 63, 30, 38, 36), 
                new Level(9, 970, 68, 34, 41, 40), 
                new Level(10, 1230, 75, 38, 47, 43), 
                new Level(11, 1530, 89, 46, 53, 49), 
                new Level(12, 1880, 96, 57, 58, 53), 
                new Level(13, 2290, 119, 63, 61, 57), 
                new Level(14, 2810, 126, 76, 65, 62), 
                new Level(15, 3550, 142, 81, 69, 68), 
                new Level(16, 4180, 148, 93, 76, 75), 
                new Level(17, 5050, 153, 114, 83, 79), 
                new Level(18, 6000, 160, 123, 89, 83), 
                new Level(19, 7180, 169, 138, 96, 90), 
                new Level(20, 8590, 174, 145, 117, 101), 
                new Level(21, 10280, 180, 151, 124, 110), 
                new Level(22, 12250, 184, 157, 135, 124), 
                new Level(23, 14460, 187, 162, 142, 137), 
                new Level(24, 17240, 192, 171, 148, 142), 
                new Level(25, 20470, 201, 179, 157, 150), 
                new Level(26, 24200, 208, 185, 163, 161), 
                new Level(27, 28370, 210, 192, 176, 172), 
                new Level(28, 33060, 213, 199, 183, 184), 
                new Level(29, 38040, 219, 213, 189, 193), 
                new Level(30, 43240, 221, 219, 211, 203), 
                new Level(31, 48800, 228, 227, 224, 212), 
                new Level(32, 54710, 231, 236, 237, 223), 
                new Level(33, 60830, 239, 240, 243, 231), 
                new Level(34, 65535, 248, 245, 247, 243), 
                new Level(35, 65535, 255, 255, 255, 255)
            };

            SetControlsEnabled(false);

        }

        struct Level
        {
            public Level(ushort index, ushort exptnl, ushort maxhp, ushort maxmp, ushort s, ushort d)
            {
                Index = index;
                ExpTNL = exptnl;
                MaxHP = maxhp;
                MaxMP = maxmp;
                Str = s;
                Def = d;
            }
            public ushort Index, ExpTNL, MaxHP, MaxMP, Str, Def;
        }

        class ItemGroup
        {
            public ItemGroup(int originX, int originY, int cellsWide, Item[] items)
            {
                m_items = items;
                for (int i = 0; i < m_items.Length; i++)
                {
                    int col = i % cellsWide;
                    int row = i / cellsWide;
                    m_items[i].Location = new Point(col * c_horizontalSpacing + originX, row * c_verticalSpacing + originY);
                }

            }
            public class Item : CheckBox
            {
                public uint Flag;

                public Item(uint flag, string name)
                {
                    Flag = flag;
                    this.AutoSize = true;
                    this.Name = "";
                    this.Size = new System.Drawing.Size(81, 17);
                    this.TabIndex = 41;
                    this.Text = name;
                    this.UseVisualStyleBackColor = true;
                }
            }
            static int c_verticalSpacing = 30;
            static int c_horizontalSpacing = 120;
            public Item[] Items {get {return m_items;}}
            private Item[] m_items;
        }

        const long c_equipmentDataOffset = 0x10E3;
        const long c_itemDataOffset = 0x10E7;
        const long c_statFieldsOffset = 0x1133;
        const long c_levelFieldOffset = 0x113F;

        ItemGroup m_items;
        ItemGroup m_equipment;
        Level[] m_levels;
        string m_fileName;

        void SetControlsEnabled(bool set)
        {
            foreach (Control c in Controls)
            {
                if (c is CheckBox)
                {
                    c.Enabled = set;
                }
                if (c is Button)
                {
                    c.Enabled = set;
                }
                if (c is TrackBar)
                {
                    c.Enabled = set;
                }
                if (c is TextBox)
                {
                    c.Enabled = set;
                }
            }
            m_tsmiReload.Enabled = set;
            m_tsmiSave.Enabled = set;
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "ZSNES Save States (*.zst, *.zs1...)|*.zs*|All files (*.*)|*.*";
            openFileDialog.Multiselect = false;
            if (openFileDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                m_fileName = openFileDialog.FileName;
                LoadFromFile(false); // Do not show prompt on startup
            }
        }

        private void LoadFromFile(bool showPrompt)
        {
            try
            {
                using (FileStream fs = new FileStream(m_fileName, FileMode.Open))
                {
                    using (BinaryReader w = new BinaryReader(fs))
                    {
                        SetControlsEnabled(true);

                        // Item data  
                        fs.Seek(c_itemDataOffset, SeekOrigin.Begin);
                        uint itemData = w.ReadUInt32();
                        for (int i = 0; i < m_items.Items.Length; i++)
                        {
                            m_items.Items[i].Checked = (itemData & m_items.Items[i].Flag) != 0;
                        }

                        // Equipment data
                        fs.Seek(c_equipmentDataOffset, SeekOrigin.Begin);
                        uint equipmentData = w.ReadUInt32();
                        for (int i = 0; i < m_equipment.Items.Length; i++)
                        {
                            m_equipment.Items[i].Checked = (equipmentData & m_equipment.Items[i].Flag) != 0;
                        }

                        // Level
                        fs.Seek(c_levelFieldOffset, SeekOrigin.Begin);
                        ushort level = w.ReadByte();
                        m_tbLevel.Text = level.ToString();

                        // Based on level, choose max hp / mp
                        ushort maxHp = m_levels[level - 1].MaxHP;
                        m_tbCurHp.SetRange(0, maxHp);
                        ushort maxMp = m_levels[level - 1].MaxMP;
                        m_tbCurMp.SetRange(0, maxMp);

                        // Current HP
                        fs.Seek(c_statFieldsOffset, SeekOrigin.Begin);
                        ushort curHp = w.ReadUInt16();
                        m_tbCurHp.Value = curHp;
                        UpdateCurHpText();

                        ushort curMp = w.ReadUInt16();
                        m_tbCurMp.Value = curMp;
                        UpdateCurMpText();

                        ushort str = w.ReadUInt16();
                        m_tbStr.Text = str.ToString();

                        ushort def = w.ReadUInt16();
                        m_tbDef.Text = def.ToString();

                        ushort gold = w.ReadUInt16();
                        m_tbGold.Text = gold.ToString();
                    }
                }
                if (showPrompt)
                {
                    MessageBox.Show("Settings reloaded.");
                }
            }
            catch (Exception exception)
            {
                MessageBox.Show("An error occurred while attempting to load the file: " + exception.Message);
            }
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                using (FileStream fs = new FileStream(m_fileName, FileMode.Open))
                {
                    using (BinaryWriter w = new BinaryWriter(fs))
                    {
                        // Item data  
                        fs.Seek(c_itemDataOffset, SeekOrigin.Begin);
                        uint itemData = 0;
                        for (int i = 0; i < m_items.Items.Length; i++)
                        {
                            if (m_items.Items[i].Checked)
                            {
                                itemData |= m_items.Items[i].Flag;
                            }
                        }
                        w.Write(itemData);

                        // Equipment
                        fs.Seek(c_equipmentDataOffset, SeekOrigin.Begin);
                        uint equipmentData = 0;
                        for (int i = 0; i < m_equipment.Items.Length; i++)
                        {
                            if (m_equipment.Items[i].Checked)
                            {
                                equipmentData |= m_equipment.Items[i].Flag;
                            }
                        }
                        w.Write(equipmentData);

                        // Level
                        fs.Seek(c_levelFieldOffset, SeekOrigin.Begin);
                        ushort level = ushort.Parse(m_tbLevel.Text);
                        w.Write(level);

                        // Current HP
                        fs.Seek(c_statFieldsOffset, SeekOrigin.Begin);
                        ushort curHp = (ushort)(m_tbCurHp.Value);
                        w.Write(curHp);

                        ushort curMp = (ushort)(m_tbCurMp.Value);
                        w.Write(curMp);

                        ushort str = ushort.Parse(m_tbStr.Text);
                        w.Write(str);

                        ushort def = ushort.Parse(m_tbDef.Text);
                        w.Write(def);

                        ushort gold = ushort.Parse(m_tbGold.Text);
                        w.Write(gold);
                    }
                }
                if (m_tsmiPromptOnSaveReload.Checked)
                {
                    MessageBox.Show("File successfully saved.");
                }
            }
            catch (Exception exception)
            {
                MessageBox.Show("An error occurred while attempting to save the file: " + exception.Message);
            }
        }

        private void closeToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void reloadToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LoadFromFile(m_tsmiPromptOnSaveReload.Checked);
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void m_btnMaxAll_Click(object sender, EventArgs e)
        {
            m_tbLevel.Text = "35";
            m_tbCurHp.Maximum = m_levels[34].MaxHP;
            m_tbCurHp.Value = m_tbCurHp.Maximum;
            m_tbCurMp.Maximum = m_levels[34].MaxMP;
            m_tbCurMp.Value = m_tbCurMp.Maximum;
            UpdateCurHpText();
            UpdateCurMpText();
            m_tbStr.Text = "255";
            m_tbDef.Text = "255";
            m_tbGold.Text = "65535";
        }

        private void m_btnCheckAllItems_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < m_items.Items.Length; i++)
            {
                m_items.Items[i].Checked = true;
            }
            for (int i = 0; i < m_equipment.Items.Length; i++)
            {
                m_equipment.Items[i].Checked = true;
            }
        }

        private void m_tbCurHp_Scroll(object sender, EventArgs e)
        {
            UpdateCurHpText();
        }

        private void m_tbCurMp_Scroll(object sender, EventArgs e)
        {
            UpdateCurMpText();
        }

        void UpdateCurHpText()
        {
            m_labelCurHp.Text = m_tbCurHp.Value.ToString() + "/" + m_tbCurHp.Maximum;
        }

        void UpdateCurMpText()
        {
            m_labelCurMp.Text = m_tbCurMp.Value.ToString() + "/" + m_tbCurMp.Maximum;
        }

        private void m_btnCheckNone_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < m_items.Items.Length; i++)
            {
                m_items.Items[i].Checked = false;
            }
            for (int i = 0; i < m_equipment.Items.Length; i++)
            {
                m_equipment.Items[i].Checked = false;
            }
        }

        private void m_tbLevel_Validating(object sender, CancelEventArgs e)
        {
            int level = 0;
            if(int.TryParse(m_tbLevel.Text, out level))
            {
                if (level >= 1 && level <= 35)
                {
                    return;
                }
            }
            MessageBox.Show("Please enter a level from 1 to 35.");
            e.Cancel = true;
        }


        private void m_tbLevel_Validated(object sender, EventArgs e)
        {
            int level = int.Parse(m_tbLevel.Text) - 1;
            m_tbCurHp.Maximum = m_levels[level].MaxHP;
            m_tbCurMp.Maximum = m_levels[level].MaxMP;
            m_tbStr.Text = m_levels[level].Str.ToString();
            m_tbDef.Text = m_levels[level].Def.ToString();
            UpdateCurHpText();
            UpdateCurMpText();
        }

        private void m_tbGold_Validating(object sender, CancelEventArgs e)
        {
            int gold = 0;
            if (int.TryParse(m_tbGold.Text, out gold))
            {
                if (gold >= 0 && gold <= 65535)
                {
                    return;
                }
            }
            MessageBox.Show("Please enter a gold amount from 0 to 65535.");
            e.Cancel = true;
        }

        private void m_tbStr_Validating(object sender, CancelEventArgs e)
        {
            int str = 0;
            if (int.TryParse(m_tbStr.Text, out str))
            {
                if (str >= 0 && str <= 255)
                {
                    return;
                }
            }
            MessageBox.Show("Please enter a STR from 0 to 255.");
            e.Cancel = true;
        }

        private void m_tbDef_Validating(object sender, CancelEventArgs e)
        {
            int def = 0;
            if (int.TryParse(m_tbDef.Text, out def))
            {
                if (def >= 0 && def <= 255)
                {
                    return;
                }
            }
            MessageBox.Show("Please enter a DEF from 0 to 255.");
            e.Cancel = true;
        }
    }
}
